Index: molecuilder/src/UIElements/CommandLineUI/CommandLineStatusIndicator.cpp
===================================================================
--- molecuilder/src/UIElements/CommandLineUI/CommandLineStatusIndicator.cpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
+++ molecuilder/src/UIElements/CommandLineUI/CommandLineStatusIndicator.cpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -0,0 +1,57 @@
+/*
+ * CommandLineStatusIndicator.cpp
+ *
+ *  Created on: May 8, 2010
+ *      Author: heber
+ */
+
+
+#include "CommandLineUI/CommandLineStatusIndicator.hpp"
+
+#include <iostream>
+
+#include "Actions/Process.hpp"
+
+using namespace std;
+
+CommandLineStatusIndicator::CommandLineStatusIndicator()
+{
+  Process::AddObserver(this);
+}
+
+CommandLineStatusIndicator::~CommandLineStatusIndicator()
+{
+  Process::RemoveObserver(this);
+}
+
+void CommandLineStatusIndicator::update(Observable *subject){
+  Process *proc;
+  // we are only observing Processes
+  if((proc=dynamic_cast<Process*>(subject))){
+    // see what kind of progress we have to display
+    if(proc->getMaxSteps()>0){
+      if(!proc->doesStop()){
+        cout << "Busy (" << proc->getName() << ") ";
+        // we can show a percentage done
+        cout << (int)proc->getDoneRatio() << "% done" << endl;
+      }
+    }
+    else{
+      // we only show some kind of busy animation
+      if(proc->doesStart()){
+        cout << "Busy (" << proc->getName() << ")";
+      }
+      if(!proc->doesStop()){
+        cout << ".";
+      }
+      else {
+        cout << endl;
+      }
+    }
+  }
+}
+
+void CommandLineStatusIndicator::subjectKilled(Observable *subject){
+
+}
+
Index: molecuilder/src/UIElements/CommandLineUI/CommandLineStatusIndicator.hpp
===================================================================
--- molecuilder/src/UIElements/CommandLineUI/CommandLineStatusIndicator.hpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
+++ molecuilder/src/UIElements/CommandLineUI/CommandLineStatusIndicator.hpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -0,0 +1,26 @@
+/*
+ * CommandLineStatusIndicator.hpp
+ *
+ *  Created on: May 8, 2010
+ *      Author: heber
+ */
+
+#ifndef COMMANDLINESTATUSINDICATOR_HPP_
+#define COMMANDLINESTATUSINDICATOR_HPP_
+
+#include "Patterns/Observer.hpp"
+
+class CommandLineStatusIndicator : public Observer
+{
+public:
+  CommandLineStatusIndicator();
+  virtual ~CommandLineStatusIndicator();
+
+  void update(Observable *subject);
+  void subjectKilled(Observable *subject);
+
+private:
+
+};
+
+#endif /* COMMANDLINESTATUSINDICATOR_HPP_ */
Index: molecuilder/src/UIElements/CommandLineUI/CommandLineUIFactory.hpp
===================================================================
--- molecuilder/src/UIElements/CommandLineUI/CommandLineUIFactory.hpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
+++ molecuilder/src/UIElements/CommandLineUI/CommandLineUIFactory.hpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -0,0 +1,28 @@
+/*
+ * CommandLineUIFactory.hpp
+ *
+ *  Created on: May 8, 2010
+ *      Author: heber
+ */
+
+#ifndef COMMANDLINEUIFACTORY_HPP_
+#define COMMANDLINEUIFACTORY_HPP_
+
+#include "UIFactory.hpp"
+
+class CommandLineUIFactory : public UIFactory
+{
+friend class UIFactory;
+
+public:
+  virtual ~CommandLineUIFactory();
+
+  virtual Dialog* makeDialog();
+  virtual MainWindow* makeMainWindow();
+
+protected:
+  CommandLineUIFactory();
+};
+
+
+#endif /* COMMANDLINEUIFACTORY_HPP_ */
Index: molecuilder/src/UIElements/CommandLineUI/CommandLineWindow.cpp
===================================================================
--- molecuilder/src/UIElements/CommandLineUI/CommandLineWindow.cpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
+++ molecuilder/src/UIElements/CommandLineUI/CommandLineWindow.cpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -0,0 +1,159 @@
+/*
+ * CommandLineWindow.cpp
+ *
+ *  Created on: May 8, 2010
+ *      Author: heber
+ */
+
+#include <boost/bind.hpp>
+
+#include "CommandLineUI/CommandLineWindow.hpp"
+#include "CommandLineUI/CommandLineStatusIndicator.hpp"
+
+#include "Actions/ActionRegistry.hpp"
+#include "Actions/AnalysisAction/PairCorrelationAction.hpp"
+#include "Actions/AnalysisAction/PairCorrelationToPointAction.hpp"
+#include "Actions/AnalysisAction/PairCorrelationToSurfaceAction.hpp"
+#include "Actions/AtomAction/AddAction.hpp"
+#include "Actions/AtomAction/ChangeElementAction.hpp"
+#include "Actions/AtomAction/RemoveAction.hpp"
+#include "Actions/CmdAction/BondLengthTableAction.hpp"
+#include "Actions/CmdAction/ElementDbAction.hpp"
+#include "Actions/CmdAction/FastParsingAction.hpp"
+#include "Actions/CmdAction/HelpAction.hpp"
+#include "Actions/CmdAction/VerboseAction.hpp"
+#include "Actions/CmdAction/VersionAction.hpp"
+#include "Actions/FragmentationAction/DepthFirstSearchAction.hpp"
+#include "Actions/FragmentationAction/SubgraphDissectionAction.hpp"
+#include "Actions/MoleculeAction/BondFileAction.hpp"
+#include "Actions/MoleculeAction/ChangeNameAction.hpp"
+#include "Actions/MoleculeAction/FillWithMoleculeAction.hpp"
+#include "Actions/MoleculeAction/LinearInterpolationofTrajectoriesAction.hpp"
+#include "Actions/MoleculeAction/SaveAdjacencyAction.hpp"
+#include "Actions/MoleculeAction/SaveBondsAction.hpp"
+#include "Actions/MoleculeAction/SaveTemperatureAction.hpp"
+#include "Actions/MoleculeAction/VerletIntegrationAction.hpp"
+#include "Actions/ParserAction/LoadXyzAction.hpp"
+#include "Actions/ParserAction/SaveXyzAction.hpp"
+#include "Actions/TesselationAction/ConvexEnvelopeAction.hpp"
+#include "Actions/TesselationAction/NonConvexEnvelopeAction.hpp"
+#include "Actions/WorldAction/AddEmptyBoundaryAction.hpp"
+#include "Actions/WorldAction/BoundInBoxAction.hpp"
+#include "Actions/WorldAction/CenterInBoxAction.hpp"
+#include "Actions/WorldAction/CenterOnEdgeAction.hpp"
+#include "Actions/WorldAction/ChangeBoxAction.hpp"
+#include "Actions/WorldAction/RemoveSphereOfAtomsAction.hpp"
+#include "Actions/WorldAction/RepeatBoxAction.hpp"
+#include "Actions/WorldAction/ScaleBoxAction.hpp"
+#include "Actions/WorldAction/SetDefaultNameAction.hpp"
+#include "Actions/WorldAction/SetGaussianBasisAction.hpp"
+#include "CommandLineParser.hpp"
+
+#include <iostream>
+
+using namespace std;
+
+// TODO: see what code can be moved to a base class for Graphic and CommandLine Windows
+CommandLineWindow::CommandLineWindow()
+{
+  // create and register all command line callable actions
+  populateAnalysisActions();
+  populateAtomActions();
+  populateCmdActions();
+  populateFragmentationActions();
+  populateMoleculeActions();
+  populateParserActions();
+  populateTesselationActions();
+  populateWorldActions();
+
+  // Add status indicators etc...
+  statusIndicator = new CommandLineStatusIndicator();
+}
+
+CommandLineWindow::~CommandLineWindow()
+{
+//  // go through all possible actions
+//  for(std::map<const std::string,Action*>::iterator ActionRunner = ActionRegistry::getInstance().getBeginIter(); ActionRegistry::getInstance().getBeginIter() != ActionRegistry::getInstance().getEndIter(); ActionRunner = ActionRegistry::getInstance().getBeginIter()) {
+//    ActionRegistry::getInstance().unregisterAction(ActionRunner->second);
+//    delete(ActionRunner->second);
+//  }
+
+  delete statusIndicator;
+}
+
+void CommandLineWindow::display() {
+  // go through all possible actions
+  for(std::map<const std::string,Action*>::iterator ActionRunner = ActionRegistry::getInstance().getBeginIter(); ActionRunner != ActionRegistry::getInstance().getEndIter(); ActionRunner++) {
+    // check whether action is present in command line
+    if (CommandLineParser::getInstance().vm.count(ActionRunner->first)) {
+      ActionRunner->second->call();
+    }
+  }
+}
+
+void CommandLineWindow::populateAnalysisActions()
+{
+  new AnalysisPairCorrelationAction();
+  new AnalysisPairCorrelationToPointAction();
+  new AnalysisPairCorrelationToSurfaceAction();
+}
+
+void CommandLineWindow::populateAtomActions()
+{
+  new AtomAddAction();
+  new AtomChangeElementAction();
+  new AtomRemoveAction();
+}
+
+void CommandLineWindow::populateCmdActions()
+{
+  new CommandLineBondLengthTableAction();
+  new CommandLineElementDbAction();
+  new CommandLineFastParsingAction();
+  new CommandLineHelpAction();
+  new CommandLineVerboseAction();
+  new CommandLineVersionAction();
+}
+
+void CommandLineWindow::populateFragmentationActions()
+{
+  new FragmentationDepthFirstSearchAction();
+}
+
+void CommandLineWindow::populateMoleculeActions()
+{
+  new MoleculeBondFileAction();
+  new MoleculeChangeNameAction();
+  new MoleculeFillWithMoleculeAction();
+  new MoleculeLinearInterpolationofTrajectoriesAction();
+  new MoleculeSaveAdjacencyAction();
+  new MoleculeSaveBondsAction();
+  new MoleculeSaveTemperatureAction();
+  new MoleculeVerletIntegrationAction();
+}
+
+void CommandLineWindow::populateParserActions()
+{
+  new ParserLoadXyzAction();
+  new ParserSaveXyzAction();
+}
+
+void CommandLineWindow::populateTesselationActions()
+{
+  new TesselationConvexEnvelopeAction();
+  new TesselationNonConvexEnvelopeAction();
+}
+
+void CommandLineWindow::populateWorldActions()
+{
+  new WorldAddEmptyBoundaryAction();
+  new WorldBoundInBoxAction();
+  new WorldCenterInBoxAction();
+  new WorldCenterOnEdgeAction();
+  new WorldChangeBoxAction();
+  new WorldRemoveSphereOfAtomsAction();
+  new WorldRepeatBoxAction();
+  new WorldScaleBoxAction();
+  new WorldSetDefaultNameAction();
+  new WorldSetGaussianBasisAction();
+}
Index: molecuilder/src/UIElements/CommandLineUI/CommandLineWindow.hpp
===================================================================
--- molecuilder/src/UIElements/CommandLineUI/CommandLineWindow.hpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
+++ molecuilder/src/UIElements/CommandLineUI/CommandLineWindow.hpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -0,0 +1,38 @@
+/*
+ * CommandLineWindow.hpp
+ *
+ *  Created on: May 8, 2010
+ *      Author: heber
+ */
+
+#ifndef COMMANDLINEWINDOW_HPP_
+#define COMMANDLINEWINDOW_HPP_
+
+#include "MainWindow.hpp"
+
+class CommandLineStatusIndicator;
+
+class CommandLineWindow : public MainWindow
+{
+public:
+  CommandLineWindow();
+  virtual ~CommandLineWindow();
+
+  virtual void display();
+
+private:
+  // populaters
+  void populateAnalysisActions();
+  void populateAtomActions();
+  void populateCmdActions();
+  void populateFragmentationActions();
+  void populateMoleculeActions();
+  void populateParserActions();
+  void populateTesselationActions();
+  void populateWorldActions();
+
+  CommandLineStatusIndicator *statusIndicator;
+
+};
+
+#endif /* COMMANDLINEWINDOW_HPP_ */
Index: molecuilder/src/UIElements/Dialog.cpp
===================================================================
--- molecuilder/src/UIElements/Dialog.cpp	(revision 3561800616d100e40c39e5a93b9765d260e50b0f)
+++ molecuilder/src/UIElements/Dialog.cpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -8,5 +8,5 @@
 #include <cassert>
 
-#include "UIElements/Dialog.hpp"
+#include "Dialog.hpp"
 
 #include "atom.hpp"
Index: molecuilder/src/UIElements/MainWindow.cpp
===================================================================
--- molecuilder/src/UIElements/MainWindow.cpp	(revision 3561800616d100e40c39e5a93b9765d260e50b0f)
+++ molecuilder/src/UIElements/MainWindow.cpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -6,5 +6,5 @@
  */
 
-#include "UIElements/MainWindow.hpp"
+#include "MainWindow.hpp"
 
 MainWindow::MainWindow()
Index: molecuilder/src/UIElements/Makefile.am
===================================================================
--- molecuilder/src/UIElements/Makefile.am	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
+++ molecuilder/src/UIElements/Makefile.am	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -0,0 +1,82 @@
+# Below is all for the User Interface
+
+INCLUDES = -I$(top_srcdir)/src -I$(top_srcdir)/src/UIElements
+
+AM_LDFLAGS = $(CPPUNIT_LIBS) -ldl
+AM_CXXFLAGS = $(CPPUNIT_CFLAGS)
+
+noinst_LIBRARIES = libMolecuilderUI.a
+libMolecuilderUI_a_SOURCES = ${UISOURCE} ${UIHEADER}
+
+VIEWSOURCE = \
+  Views/View.cpp \
+  Views/StringView.cpp \
+  Views/MethodStringView.cpp \
+  Views/StreamStringView.cpp
+VIEWHEADER = \
+  Views/View.hpp \
+  Views/StringView.hpp \
+  Views/MethodStringView.hpp \
+  Views/StreamStringView.hpp
+
+MENUSOURCE = \
+  Menu/Menu.cpp \
+  Menu/TextMenu.cpp \
+  Menu/MenuItem.cpp \
+  Menu/SubMenuItem.cpp \
+  Menu/ActionMenuItem.cpp \
+  Menu/SeperatorItem.cpp \
+  Menu/DisplayMenuItem.cpp
+  
+MENUHEADER = \
+  Menu/Menu.hpp \
+  Menu/TextMenu.hpp \
+  Menu/MenuItem.hpp \
+  Menu/SubMenuItem.hpp \
+  Menu/ActionMenuItem.hpp \
+  Menu/SeperatorItem.hpp \
+  Menu/DisplayMenuItem.hpp
+
+UISOURCE = \
+  ${ACTIONSSOURCE} \
+  ${COMMANDLINEUISOURCE} \
+  ${MENUSOURCE} \
+  ${TEXTUISOURCE} \
+  ${VIEWSOURCE} \
+  Dialog.cpp \
+  MainWindow.cpp \
+  UIFactory.cpp
+  
+UIHEADER = \
+  ${ACTIONSHEADER} \
+  ${COMMANDLINEUIHEADER} \
+  ${MENUHEADER} \
+  ${TEXTUIHEADER} \
+  ${VIEWHEADER} \
+  Dialog.hpp \
+  MainWindow.hpp \
+  UIFactory.hpp
+
+TEXTUISOURCE = \
+  TextUI/TextDialog.cpp \
+  TextUI/TextStatusIndicator.cpp \
+  TextUI/TextUIFactory.cpp \
+  TextUI/TextWindow.cpp
+TEXTUIHEADER = \
+  TextUI/TextDialog.hpp \
+  TextUI/TextStatusIndicator.hpp \
+  TextUI/TextUIFactory.hpp \
+  TextUI/TextWindow.hpp
+
+COMMANDLINEUISOURCE = \
+  CommandLineUI/CommandLineDialog.cpp \
+  CommandLineUI/CommandLineStatusIndicator.cpp \
+  CommandLineUI/CommandLineUIFactory.cpp \
+  CommandLineUI/CommandLineWindow.cpp
+COMMANDLINEUIHEADER = \
+  CommandLineUI/CommandLineDialog.hpp \
+  CommandLineUI/CommandLineStatusIndicator.hpp \
+  CommandLineUI/CommandLineUIFactory.hpp \
+  CommandLineUI/CommandLineWindow.hpp
+
+
Index: molecuilder/src/UIElements/Menu/ActionMenuItem.cpp
===================================================================
--- molecuilder/src/UIElements/Menu/ActionMenuItem.cpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
+++ molecuilder/src/UIElements/Menu/ActionMenuItem.cpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -0,0 +1,30 @@
+/*
+ * ActionMenuItem.cpp
+ *
+ *  Created on: Dec 11, 2009
+ *      Author: crueger
+ */
+
+#include <iostream>
+
+#include "Menu/ActionMenuItem.hpp"
+#include "Actions/MethodAction.hpp"
+
+using namespace std;
+
+ActionMenuItem::ActionMenuItem(char _trigger, const char* _description,Menu* _menu,Action* _action)
+: MenuItem(_trigger,_description,_menu),
+  action(_action)
+{
+}
+
+ActionMenuItem::~ActionMenuItem()
+{}
+
+void ActionMenuItem::doTrigger() {
+  action->call();
+}
+
+bool ActionMenuItem::isActive() {
+  return action->isActive();
+}
Index: molecuilder/src/UIElements/Menu/ActionMenuItem.hpp
===================================================================
--- molecuilder/src/UIElements/Menu/ActionMenuItem.hpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
+++ molecuilder/src/UIElements/Menu/ActionMenuItem.hpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -0,0 +1,34 @@
+/*
+ * ActionMenuItem.h
+ *
+ *  Created on: Dec 11, 2009
+ *      Author: crueger
+ */
+
+#ifndef ACTIONMENUITEM_H_
+#define ACTIONMENUITEM_H_
+
+#include <string>
+
+#include "Menu/MenuItem.hpp"
+
+class Action;
+
+/**
+ * Produce MenuItems that take an appropriate action when called.
+ */
+class ActionMenuItem : public MenuItem
+{
+public:
+  ActionMenuItem(char,const char*,Menu*,Action*);
+  virtual ~ActionMenuItem();
+
+  virtual void doTrigger();
+
+  virtual bool isActive();
+
+private:
+  Action* action; //!< this action will be called when the trigger matches
+};
+
+#endif /* ACTIONMENUITEM_H_ */
Index: molecuilder/src/UIElements/Menu/DisplayMenuItem.cpp
===================================================================
--- molecuilder/src/UIElements/Menu/DisplayMenuItem.cpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
+++ molecuilder/src/UIElements/Menu/DisplayMenuItem.cpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -0,0 +1,59 @@
+/*
+ * DisplayMenuItem.cpp
+ *
+ *  Created on: Dec 14, 2009
+ *      Author: crueger
+ */
+
+#include <sstream>
+#include <cmath>
+
+#include "Menu/DisplayMenuItem.hpp"
+#include "Views/StringView.hpp"
+
+
+DisplayMenuItem::DisplayMenuItem(Menu* _menu, StringView *_view):
+MenuItem('\0',"",_menu),
+view(_view),
+title("")
+{
+}
+
+DisplayMenuItem::DisplayMenuItem(Menu* _menu, StringView *_view, string _title, char _spacer, int _length ):
+  MenuItem('\0',"",_menu),
+  view(_view),
+  title(_title),
+  length(_length),
+  spacer(_spacer)
+{
+}
+
+DisplayMenuItem::~DisplayMenuItem()
+{}
+
+
+void DisplayMenuItem::doTrigger(){}
+bool DisplayMenuItem::checkTrigger(char c){
+  return false;
+}
+
+const string DisplayMenuItem::formatEntry(){
+  stringstream s;
+  if(title.length()>0) {
+    int pre = floor((length-title.length())/2.0);
+    int post = ceil((length-title.length())/2.0);
+    for(int i=0;i<pre;i++)
+      s << spacer;
+    s << title;
+    for(int i=0;i<post;i++)
+          s << spacer;
+    s << "\n";
+  }
+  s << view->toString();
+  return s.str();
+}
+
+
+const string DisplayMenuItem::getDescription(){
+  return string("");
+}
Index: molecuilder/src/UIElements/Menu/DisplayMenuItem.hpp
===================================================================
--- molecuilder/src/UIElements/Menu/DisplayMenuItem.hpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
+++ molecuilder/src/UIElements/Menu/DisplayMenuItem.hpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -0,0 +1,43 @@
+/*
+ * DisplayMenuItem.hpp
+ *
+ *  Created on: Dec 14, 2009
+ *      Author: crueger
+ */
+
+#ifndef DISPLAYMENUITEM_HPP_
+#define DISPLAYMENUITEM_HPP_
+
+#include "Menu/MenuItem.hpp"
+#include "defs.hpp"
+
+class StringView;
+
+/**
+ * Display any kind of StringView within a Menu
+ *
+ * Any trigger are ignored for this type of Item
+ */
+class DisplayMenuItem : public MenuItem
+{
+public:
+  DisplayMenuItem(Menu* _menu, StringView *_view);
+  DisplayMenuItem(Menu* _menu, StringView *_view, string _title,
+                  char _spacer=STD_MENU_TITLE_SPACER, int _length=STD_MENU_LENGTH);
+  virtual ~DisplayMenuItem();
+
+  virtual void doTrigger();
+  virtual bool checkTrigger(char);
+
+  virtual const string formatEntry();
+
+  virtual const string getDescription();
+
+private:
+  StringView *view;
+  string title;
+  int length;
+  char spacer;
+};
+
+#endif /* DISPLAYMENUITEM_HPP_ */
Index: molecuilder/src/UIElements/Menu/Menu.hpp
===================================================================
--- molecuilder/src/UIElements/Menu/Menu.hpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
+++ molecuilder/src/UIElements/Menu/Menu.hpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -0,0 +1,41 @@
+/*
+ * Menu.h
+ *
+ *  Created on: Dec 10, 2009
+ *      Author: crueger
+ */
+
+#ifndef MENU_MENU_H_
+#define MENU_MENU_H_
+
+using namespace std;
+
+class MenuItem;
+
+/**
+ * Base class for all Types of menus
+ * contains basic abstract functionality to add Items, remove Items and display the menu
+ *
+ * TODO: Make sure all items are only added once.
+ */
+class Menu
+{
+public:
+  Menu();
+  virtual ~Menu();
+
+
+  /**
+   * Adding and removing should be handled by the items.
+   */
+  virtual void addItem(MenuItem*)=0;
+  /**
+   * Adding and removing should be handled by the items.
+   */
+  virtual void removeItem(MenuItem*)=0;
+  virtual void display()=0;
+
+private:
+};
+
+#endif /* MENU_H_ */
Index: molecuilder/src/UIElements/Menu/MenuItem.cpp
===================================================================
--- molecuilder/src/UIElements/Menu/MenuItem.cpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
+++ molecuilder/src/UIElements/Menu/MenuItem.cpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -0,0 +1,83 @@
+/*
+ * MenuItem.cpp
+ *
+ *  Created on: Dec 10, 2009
+ *      Author: crueger
+ */
+
+
+
+#include "Menu/MenuItem.hpp"
+#include "Menu/Menu.hpp"
+#include <sstream>
+#include <iostream>
+
+/**
+ * produce a new MenuItem using with a description and a trigger.
+ * The MenuItem is then added to the menu passed to it.
+ */
+MenuItem::MenuItem(char _trigger, const char* _description,Menu* menu) :
+trigger(_trigger),
+added(false)
+{
+  description = new string(_description);
+  add_to_menu(menu);
+}
+
+MenuItem::~MenuItem()
+{
+  delete description;
+}
+
+/**
+ * check if the trigger matches and call doTrigger if it does.
+ */
+bool MenuItem::checkTrigger(char key) {
+  if(key == trigger) {
+    doTrigger();
+    return true;
+  }
+  else
+    return false;
+
+}
+
+char MenuItem::getTrigger() {
+  return trigger;
+}
+
+const string MenuItem::getDescription() {
+  return *description;
+}
+
+/**
+ * Produce a formated output of this item containing trigger and description
+ * Normal format is: "<trigger> - <description>"
+ */
+const string MenuItem::formatEntry(){
+  stringstream s;
+  s << getTrigger() << " - " << getDescription();
+
+  return s.str();
+}
+
+
+/**
+ * check if this item is within a menu and add to menu if it is not yet contained anywhere
+ *
+ * TODO: include funtionality to move Items from one menu to another
+ */
+void MenuItem::add_to_menu(Menu* menu) {
+  if(!wasAdded()) {
+    menu->addItem(this);
+    added=true;
+  }
+}
+
+bool MenuItem::wasAdded(){
+  return added;
+}
+
+bool MenuItem::isActive(){
+  return true;
+}
Index: molecuilder/src/UIElements/Menu/MenuItem.hpp
===================================================================
--- molecuilder/src/UIElements/Menu/MenuItem.hpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
+++ molecuilder/src/UIElements/Menu/MenuItem.hpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -0,0 +1,49 @@
+/*
+ * MenuItem.h
+ *
+ *  Created on: Dec 10, 2009
+ *      Author: crueger
+ */
+
+#ifndef MENUITEM_H_
+#define MENUITEM_H_
+
+#include <string>
+
+using namespace std;
+
+class Menu;
+
+/**
+ * Base class for all kinds of MenuItems
+ *
+ * This class takes care of checking the triggers and performing appropriate actions.
+ */
+class MenuItem {
+public:
+  MenuItem(char,const char*,Menu*);
+  virtual ~MenuItem();
+
+  virtual void doTrigger()=0;
+  virtual bool checkTrigger(char);
+
+  virtual const string formatEntry();
+
+  virtual const string getDescription();
+  char getTrigger();
+
+  void add_to_menu(Menu*);
+  bool wasAdded();
+
+  virtual bool isActive();
+
+protected:
+  void setDescription(string);
+
+private:
+  char trigger;
+  string *description;
+  bool added;
+};
+
+#endif /* MENUITEM_H_ */
Index: molecuilder/src/UIElements/Menu/SeperatorItem.hpp
===================================================================
--- molecuilder/src/UIElements/Menu/SeperatorItem.hpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
+++ molecuilder/src/UIElements/Menu/SeperatorItem.hpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -0,0 +1,36 @@
+/*
+ * SeperatorItem.h
+ *
+ *  Created on: Dec 11, 2009
+ *      Author: crueger
+ */
+
+#ifndef SEPERATORITEM_H_
+#define SEPERATORITEM_H_
+
+#include "Menu/MenuItem.hpp"
+
+/**
+ * Produce a Seperator within a Menu.
+ *
+ * All triggers are ignored for this Item.
+ */
+class SeperatorItem : public MenuItem
+{
+public:
+  SeperatorItem(Menu*);
+  SeperatorItem(Menu*,char,int);
+  virtual ~SeperatorItem();
+
+  virtual void doTrigger();
+  virtual bool checkTrigger(char);
+
+  virtual const string getDescription();
+
+  virtual const string formatEntry();
+private:
+  char spacer;
+  int length;
+};
+
+#endif /* SEPERATORITEM_H_ */
Index: molecuilder/src/UIElements/Menu/SubMenuItem.cpp
===================================================================
--- molecuilder/src/UIElements/Menu/SubMenuItem.cpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
+++ molecuilder/src/UIElements/Menu/SubMenuItem.cpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -0,0 +1,23 @@
+/*
+ * SubMenuItem.cpp
+ *
+ *  Created on: Dec 10, 2009
+ *      Author: crueger
+ */
+
+#include "SubMenuItem.hpp"
+
+SubMenuItem::SubMenuItem(char _trigger,const char* _description,Menu* _parent, Menu* _theMenu) :
+MenuItem(_trigger,_description,_parent),
+theMenu(_theMenu)
+{
+}
+
+SubMenuItem::~SubMenuItem()
+{
+  delete theMenu;
+}
+
+void SubMenuItem::doTrigger() {
+  theMenu->display();
+}
Index: molecuilder/src/UIElements/Menu/SubMenuItem.hpp
===================================================================
--- molecuilder/src/UIElements/Menu/SubMenuItem.hpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
+++ molecuilder/src/UIElements/Menu/SubMenuItem.hpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -0,0 +1,20 @@
+#ifndef SUBMENUITEM_H_
+#define SUBMENUITEM_H_
+
+#include "MenuItem.hpp"
+#include "TextMenu.hpp"
+
+class Menu;
+
+class SubMenuItem : public MenuItem
+{
+public:
+  SubMenuItem(char,const char*,Menu*,Menu*);
+  virtual ~SubMenuItem();
+
+  virtual void doTrigger();
+private:
+  Menu* theMenu;
+};
+
+#endif /* SUBMENUITEM_H_ */
Index: molecuilder/src/UIElements/Menu/TextMenu.cpp
===================================================================
--- molecuilder/src/UIElements/Menu/TextMenu.cpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
+++ molecuilder/src/UIElements/Menu/TextMenu.cpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -0,0 +1,141 @@
+/*
+ * TextMenu.cpp
+ *
+ *  Created on: Dec 10, 2009
+ *      Author: crueger
+ */
+
+#include <boost/bind.hpp>
+#include <iostream>
+#include <cmath>
+#include "Menu/TextMenu.hpp"
+#include "Menu/MenuItem.hpp"
+#include "Helpers/Assert.hpp"
+
+
+/**
+ * produce a text menu with a given title.
+ * The text will later be displayed using the stream passed to the constructor.
+ */
+TextMenu::TextMenu(ostream& _outputter, string _title, char _spacer,int _length) :
+  defaultItem(0),
+  outputter(_outputter),
+  title(_title),
+  spacer(_spacer),
+  length(_length),
+  quit(false)
+{
+}
+
+TextMenu::~TextMenu()
+{
+  for(list<MenuItem*>::iterator it=items.begin(); it != items.end(); it++)
+    delete (*it);
+}
+
+
+void TextMenu::addItem(MenuItem* item) {
+  items.push_back(item);
+}
+
+void TextMenu::removeItem(MenuItem* item) {
+  items.remove(item);
+}
+
+void TextMenu::doQuit(){
+  quit = true;
+}
+
+bool TextMenu::hasQuit(){
+  return quit;
+}
+
+void TextMenu::showEntry(MenuItem* entry){
+  if(entry->isActive()==false){
+    outputter << "(";
+  }
+  outputter << entry->formatEntry();
+  if(entry->isActive()==false){
+    outputter << ")";
+  }
+  outputter << "\n";
+}
+
+void TextMenu::display() {
+  char choice;
+  bool somethingChosen = false;
+  quit = false;
+  do {
+    int pre = floor((length - title.length()) /2.0);
+    int post = ceil((length - title.length()) /2.0);
+    for(int i=0;i<pre;i++)
+      outputter << spacer;
+    outputter << title;
+    for(int i=0;i<post;i++)
+          outputter << spacer;
+    outputter << '\n';
+    for_each(items.begin(), items.end(), boost::bind(&TextMenu::showEntry,this,_1));
+    outputter.flush();
+
+    cin >> choice;
+
+    list<MenuItem*>::iterator iter;
+    for(iter = items.begin(); iter!=items.end();iter++){
+      if((*iter)->isActive()){
+        somethingChosen |= (*iter)->checkTrigger(choice);
+      }
+    }
+    // see if something was chosen and call default Item if not
+    if(!somethingChosen) {
+      if(defaultItem){
+        defaultItem->doTrigger();
+      }
+      else{
+        outputter << "Invalid Choice!" <<  endl;
+      }
+    }
+  }while (!hasQuit());
+}
+
+string TextMenu::getTitle(){
+  return title;
+}
+
+void TextMenu::addDefault(MenuItem* _defaultItem) {
+  defaultItem = _defaultItem;
+}
+
+/****************************** Contained Actions ****************/
+
+const string TextMenu::LeaveAction::nameBase = "Leave menu: ";
+
+TextMenu::LeaveAction::LeaveAction(TextMenu* _menu) :
+Action(nameBase+_menu->getTitle()),
+menu(_menu)
+{}
+
+TextMenu::LeaveAction::~LeaveAction(){}
+
+bool TextMenu::LeaveAction::canUndo(){
+  return false;
+}
+
+bool TextMenu::LeaveAction::shouldUndo(){
+  return false;
+}
+
+Action::state_ptr TextMenu::LeaveAction::performCall(){
+  menu->doQuit();
+  return Action::success;
+}
+
+
+Action::state_ptr TextMenu::LeaveAction::performUndo(Action::state_ptr){
+  ASSERT(0,"Cannot undo leaving a menu");
+  return Action::success;
+}
+
+Action::state_ptr TextMenu::LeaveAction::performRedo(Action::state_ptr){
+  ASSERT(0,"Cannot redo leaving a menu");
+  return Action::success;
+}
Index: molecuilder/src/UIElements/Menu/TextMenu.hpp
===================================================================
--- molecuilder/src/UIElements/Menu/TextMenu.hpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
+++ molecuilder/src/UIElements/Menu/TextMenu.hpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -0,0 +1,82 @@
+/*
+ * TextMenu.h
+ *
+ *  Created on: Dec 10, 2009
+ *      Author: crueger
+ */
+
+#ifndef TEXTMENU_H_
+#define TEXTMENU_H_
+
+#include <list>
+#include <ostream>
+#include <string>
+
+#include "Menu/Menu.hpp"
+#include "Actions/Action.hpp"
+#include "defs.hpp"
+
+class MenuItem;
+
+/**
+ * Used to produce any kind of text menu
+ *
+ * All Items are displayed and user is prompted for a key. The item corresponding to that key is then activated.
+ */
+class TextMenu : public Menu
+{
+public:
+  class LeaveAction : public Action {
+  public:
+    LeaveAction(TextMenu*);
+    virtual ~LeaveAction();
+
+    bool canUndo();
+    bool shouldUndo();
+
+  private:
+    virtual Action::state_ptr performCall();
+    virtual Action::state_ptr performUndo(Action::state_ptr);
+    virtual Action::state_ptr performRedo(Action::state_ptr);
+
+    TextMenu* menu;
+
+    static const string nameBase;
+  };
+
+  TextMenu(ostream& _outputter, string _title, char _spacer=STD_MENU_TITLE_SPACER,int _length=STD_MENU_LENGTH);
+  virtual ~TextMenu();
+
+  virtual void addItem(MenuItem*);
+  virtual void removeItem(MenuItem*);
+  virtual void display();
+  virtual string getTitle();
+
+  /**
+   * Call doQuit if you want to return from this menu.
+   */
+  virtual void doQuit();
+  /**
+   * Check whether someone has chosen to quit
+   */
+  virtual bool hasQuit();
+
+  virtual void addDefault(MenuItem*);
+
+protected:
+  virtual void showEntry(MenuItem*);
+
+private:
+  list<MenuItem*> items;
+
+  MenuItem* defaultItem;
+
+  ostream& outputter;
+  string title;
+  char spacer;
+  int length;
+
+  bool quit;
+};
+
+#endif /* TEXTMENU_H_ */
